      subroutine cpds(deg,deg0,edge,edge0,first,first0,
     +               n2e,next,next0,
     +               nv,v,v0,vertex)
c     ------------------------------------------------------------------
c
c     cpds: Copy original data structure into work data structure.
c
c     ------------------------------------------------------------------
c
c     Passed input scalars:
c
c          n2e    - array dimension = 2*ne
c          nv     - number of nodes in graph
c
c     ------------------------------------------------------------------
      implicit  none
      integer   n2e,nv

c     ------------------------------------------------------------------
c
c     Passed input arrays:
c
c         deg0    - degree of vertex
c         edge0   - edge
c         first0  - pointer to start of adjacency list (original)
c         next0   - pointer to next element of adjacency
c                   list (copy)
c         vertex  - existence of vertex in S U Sbar
c         v0      - vertex in adjacency list (original)
c
c     ------------------------------------------------------------------
      integer    deg0(nv),edge0(n2e),first0(nv),
     +           next0(n2e),
     +           vertex(nv),v0(n2e)

c     ------------------------------------------------------------------
c
c     Passed output arrays:
c
c         deg    - degree of vertex (copy)
c         edge   - edge
c         first  - pointer to start of adjacency list (copy)
c         next   - pointer to next element of adjacency
c                  list (copy)
c         v      - vertex in adjacency list (copy)
c
c     ------------------------------------------------------------------
      integer    deg(nv),edge(n2e),first(nv),
     +           next(n2e),v(n2e)

c     ------------------------------------------------------------------
c
c     Local scalars:
c    
c          i     - do loop index
c    
c     ------------------------------------------------------------------
      integer    i

c     ------------------------------------------------------------------
c     cpi4(n,x,y): Copy the n-dimensional array x into 
c                  the n-dimensional array y
c     ------------------------------------------------------------------
      call cpi4(nv,deg0,deg)
      call cpi4(n2e,edge0,edge)
      call cpi4(nv,first0,first)
      call cpi4(n2e,next0,next)
      call cpi4(n2e,v0,v)

c     ------------------------------------------------------------------
c     Initialize vertex to mean that no vertex is in set S or Sbar.
c     ------------------------------------------------------------------
      do 10 i=1,nv
           vertex(i)=0
10    continue

c     ------------------------------------------------------------------
      return
c
c     ------------------------------------------------------------------
c     End of subroutine cpds.
c     ------------------------------------------------------------------
c
      end
