      subroutine dflset(alpha,hammd,look4,maxitr,nmxelt,pron,prttyp,
     +                  seedd,seedp)
c     ------------------------------------------------------------------
c
c     dflset: Sets default values for parameters.
c
c     ------------------------------------------------------------------
c
c     Passed output scalars:
c
c          alpha  - rcl parameter
c          look4  - size of cutset sought
c          maxitr - maximum number of GRASP iterations
c          nmxelt - maximum number of elite elements
c          pron   - indicator of path relinking (on/off)
c          prttyp - iteration summary report
c                   = 0 - silent
c                   = 1 - show improvements only
c                   = 2 - show all iterations
c          seedd  - seed for pseudo random number generator
c          seedp  - seed for path relinking
c 
c     ------------------------------------------------------------------
      implicit         none
      integer          look4,maxitr,nmxelt,pron,prttyp,seedp
      real             alpha,hammd
      double precision seedd
c     ------------------------------------------------------------------
      alpha=-1.0
      seedd=270002.d0
      seedp=270002
      maxitr=1024
      prttyp=1
      look4=2147483647
      nmxelt=10
      hammd=0.25
      pron=0

c     ------------------------------------------------------------------
      return
c
c     ------------------------------------------------------------------
c     end subroutine dflset
c     ------------------------------------------------------------------
c
      end
