      subroutine errmsg(errcnd,out)
c     ------------------------------------------------------------------
c
c     errmsg: Prints out error message corresponding to error condition
c             given by errcnd (returned from gfvs).
c
c     ------------------------------------------------------------------
c
c     Passed input scalar:
c
c       errcnd - error condition number
c
c          successful termination
c
c                 = 0    - found target look4 in fewer than maxitr
c                          iterations
c
c          unsuccessful termination
c
c                 = 1    - nv too big
c                 = 2    - ne too big 
c                 = 3    - input vertex label invalid 
c                 = 4    - cutset size too small or too big
c                 = 5    - maxitr too small 
c                 = 6    - prttyp invalid 
c                 = 7    - invalid seed 
c
c
c          out    - Fortran output device
c
c     ------------------------------------------------------------------
      implicit   none
      integer errcnd,out

c     ------------------------------------------------------------------
      if (errcnd .eq. 1) then
         write(out,10)
10       format(' error: number of vertices too big. Increase maxv.')
      endif

      if (errcnd .eq. 2) then 
         write(out,20)
20       format(' error: number of arcs too big. Increase maxe.')
      endif

      if (errcnd .eq. 3) then
         write(out,30)
30       format(' error: node number is not valid.')
      endif

      if (errcnd .eq. 4) then
         write(out,40)
40       format(' error: value of look4 is not valid.')
      endif

      if (errcnd .eq. 5) then
         write(out,50)
50       format(' error: value of maxitr is not valid.')
      endif

      if (errcnd .eq. 6) then
         write(out,60)
60       format(' error: value of prttyp is not valid.')
      endif

      if(errcnd .eq. 7) then
         write(out,70)
70       format(' error: value of seed is not valid.')
      endif

      if(errcnd .eq. 0) then
         write(out,80)
80       format(//,'     Execution terminated with no error.')
      endif

c     ------------------------------------------------------------------
      return
c
c     ------------------------------------------------------------------
c     end subroutine errmsg
c     ------------------------------------------------------------------
c
      end
