      subroutine move(edge,delta,first,ne,n2e,next,nA,nB,nv,setA,setB,
     +                sumA,sumB,v,w)
c     ------------------------------------------------------------------
c
c     move: Move one element from setA to setB and update 
c           the arrays sumA and sumB.
c
c     ------------------------------------------------------------------
c
c     Passed input scalars:
c
c          ne    
c          n2e    
c          nv    
c          nA
c          nB
c
c     ------------------------------------------------------------------
      implicit   none
      integer    ne,n2e,nv,nA,nB

c     ------------------------------------------------------------------
c
c     Passed input/output arrays:
c
c          first
c          next
c          setA
c          setB
c          sumA
c          sumB 
c          v
c          w
c
c     ------------------------------------------------------------------
      integer    edge(n2e),first(nv),next(n2e),setA(nv),
     +           setB(nv),sumA(nv),sumB(nv),v(n2e),w(ne)

c     ------------------------------------------------------------------
c
c     Passed output scalar:
c
c          delta
c
c     ------------------------------------------------------------------
      integer delta

c     ------------------------------------------------------------------
c
c     Local scalars:
c
c          e     - pointer to arc
c          i     - do loop index
c          node  - pointer to vertex 
c          u     - pointer to vertex
c
c     ------------------------------------------------------------------
      integer    e,i,u,node

c     ------------------------------------------------------------------
      do 999 i=1,nA
	   if (setA(i).lt.0) then
		print *,'setA(i) < 0: i,setA(i)= ',i,setA(i)
		stop
           endif
999   continue
      do 998 i=1,nB
	   if (setB(i).lt.0) then
		print *,'setB(i) < 0: i,setA(i)= ',i,setB(i)
		stop
           endif
998   continue
      node=setA(1)

      do 10 i=2,nA
         setA(i-1)=setA(i)
10    continue

      if (sumA(node) .lt. sumB(node)) then
c          -------------------------------------------------------------
c          No move.
c          -------------------------------------------------------------
           setA(nA)=node
	   delta=0

      else
c          -------------------------------------------------------------
c          Move.
c          -------------------------------------------------------------
	   delta=sumA(node)-sumB(node)
           nA=nA-1
           nB=nB+1
           setB(nB)=node

c          -------------------------------------------------------------
c          Update SUMa and SUSMb.
c          -------------------------------------------------------------
           e=first(node)

20         if (e .eq. 0) goto 30
                u=v(e)
                sumA(u)=sumA(u)-w(edge(e))
                sumB(u)=sumB(u)+w(edge(e))
                e=next(e)
                goto 20
30         continue
      endif

      return
c
c     ------------------------------------------------------------------
c     end subroutine move
c     ------------------------------------------------------------------
      end
