      subroutine outsol(bestz,bS,gitrb,nbS,nv,out,seedb,
     +                  vertex,ne,vtx1,vtx2,w)
c     ------------------------------------------------------------------
c     outsol: Prints out solution.
c     ------------------------------------------------------------------
      implicit none
      integer bestz,gitrb,nbS,nv,out,seedb,i,j,k,ne
      integer bS(nv),vertex(nv)
      integer vtx1(ne),vtx2(ne),w(ne),sumw(nv),maxsum,huge
      integer npart,maxnod
      huge=2147483647

c     ------------------------------------------------------------------
c     Build vertex array: vertex(i)=1 -> node i is in partition 1
c                         vertex(i)=2 -> node i is in partition 2
c     ------------------------------------------------------------------
      npart=0
      do 10 i=1,nv
           vertex(i)=2
10    continue
      do 20 i=1,nbS
           vertex(bS(i))=1
           npart=npart+1
20    continue

c     ------------------------------------------------------------------
c     Print header.
c     ------------------------------------------------------------------
      write(out,25) 
25    format(//,'----------------------------------------------------',
     +       /, ' Best solution found',//) 

c     ------------------------------------------------------------------
c     Print solution.
c     ------------------------------------------------------------------
      write(out,30) bestz
30    format('                weight of best cut found: ',i10) 
      write(out,40) seedb
40    format(' seed at start of itr best cut was found: ',i10) 
      write(out,45) gitrb
45    format('      GRASP iteration best cut was found: ',i10) 
      write(out,50) 
50    format(/,' best cut: ',//,' partition 1:',/)
      do 60 i=1,nv
            if (vertex(i).eq.1) then
                 write(out,70) i
70               format('       node: ',i6)
            endif
60    continue
      write(out,65) 
65    format(/,' partition 2:',/)
      do 80 i=1,nv
            if (vertex(i).eq.2) then
                 write(out,70) i
            endif
80    continue
      write(out,90) 
90    format(//,'----------------------------------------------------')

      if (npart .eq. 0 .or. npart .eq. nv) then
           write(out,1000) 
1000       format('THE BEST CUT FOUND HAS AN EMPTY PARTITION....') 
           write(out,1001) 
1001       format(' ') 
           write(out,1002) 
1002       format('Looking for best cut with a non-empty partition.') 
           write(out,1001) 
           do 100 k=1,nv
                sumw(k)=0
100        continue
           do 101 k=1,ne
                i=vtx1(k)
                j=vtx2(k)
                sumw(i)=sumw(i)+w(k)
                sumw(j)=sumw(j)+w(k)
101        continue
           maxsum=-huge
           do 102 k=1,nv
                if (sumw(k) .ge. maxsum) then
                     maxsum=sumw(k)
                     maxnod=k
                endif
102        continue
           write(out,930) maxsum
930        format('          weight of best non-empty cut found: ',i10) 
           write(out,950) 
950        format(/,' best non-empty cut: ',//,' partition 1:',/)
           write(out,970) maxnod
970        format('       node: ',i6)
960        continue
           write(out,965) 
965        format(/,' partition 2:',/)
           do 980 i=1,nv
                  if (i .ne. maxnod) then
                      write(out,970) i
                  endif
980        continue
           write(out,990) 
990        format(//,'----------------------------------------------')
      endif
      return

c     ------------------------------------------------------------------
c     End of subroutine outsol.
c     ------------------------------------------------------------------
      end
