      subroutine pathrl(bestz,bnS,bS,edge,faselt,felt,
     +                  first,gitr,gitrb,indb,indw,mindif,
     +                  n2e,ne,nS,
     +                  nelt,next,
     +                  nmelt,nmxelt,nv,nxtelt,objelt,objf,S,
     +                  seedp,seed0,seedb,
     +                  sums,sumsb,symdif,tmpx,tmpy,
     +                  v,velt,w,
     +                  worstz,x,y,zimprv,optS,vtx1,vtx2,x0,
     +                  xdiff,ydiff,optz,noptS)

c     ------------------------------------------------------------------
c     pathrl: Path relinking from current S to target from Elite set.
c     ------------------------------------------------------------------
      implicit none
      integer HUGE
      parameter (HUGE=2147483647)
      integer i,ptr,ndiff,mindif,ne,n2e,nv,nmelt,optz,optzf,flag
      integer bestz,faselt,indb,indw,nS,nelt,nmxelt,objf,worstz,zimprv
      integer bnS,gitr,gitrb,seed0,seedb,seedp,target,bestx,node
      integer cost,bestxi,bestxn,elitex,noptS,objt
      integer bS(nv),felt(nmxelt),nxtelt(nmelt),S(nv),velt(nmelt),
     +        objelt(nmxelt),x(nv),y(nv),sums(nv),sumsb(nv),optS(nv),
     +        x0(nv),xdiff(nv),ydiff(nv)
      integer first(nv),edge(n2e),next(n2e),v(n2e),w(ne),symdif(nv),
     +        tmpx(nv),tmpy(nv),ntmpx,ntmpy,redo,vtx1(ne),vtx2(ne)
      real    xrand,randp

c     ------------------------------------------------------------------
c     Save objf costs.
c     ------------------------------------------------------------------
      optz=objf
      noptS=nS
      call cpi4(nS,S,optS)
      flag=0
c     print *,'PR:  objf: ',objf
c     print *,'PR:  nelt: ',nelt
c     print *,'PR:  sums: ',(sums(i),i=1,nv)
c     print *,'PR:  sumsb: ',(sumsb(i),i=1,nv)
c     print *,'PR:  objelt: ',(objelt(i),i=1,nelt)
c     print *,' nelt = ',nelt,' target solution = '
c     call myflsh
      do 5090 target=1,nelt
           ptr=felt(target)
           do 5091 i=1,nv
                y(i)=0
5091       continue
3090       if (ptr .eq. 0) goto 4090
                y(velt(ptr))=1
                ptr=nxtelt(ptr)
	        goto 3090
4090       continue
5090  continue

c     ------------------------------------------------------------------
c     Select target at random from elite set.
c     ------------------------------------------------------------------
      xrand=randp(seedp)
      target=1+seedp/(2147483647/nelt)
c     print *,'PR: target index = ',target

cxxx  redo=1
      redo=0
  
c     ------------------------------------------------------------------
c     Compute symmetric difference between S and target.
c     ------------------------------------------------------------------
      do 10 i=1,nv
           x(i)=0
           y(i)=0
10    continue
      do 20 i=1,nS
           x(S(i))=1
20    continue
      ntmpx=0
      ptr=felt(target)
30    if (ptr .eq. 0) goto 40
           y(velt(ptr))=1
c          save target in (ntmpx,tmpx)
	   ntmpx=ntmpx+1
	   tmpx(ntmpx)=velt(ptr)
           ptr=nxtelt(ptr)
	   goto 30
40    continue
      objt=objelt(target)
c     print *,'PR: target y = ',(y(i),i=1,nv)
c     ------------------------------------------------------------------
c     Compute symmetric difference between S and target elite solution.
c     ------------------------------------------------------------------
      ndiff=0
      ntmpy=0
      do 50 i=1,nv
           if (x(i).ne.y(i)) then
	        ndiff=ndiff+1
		symdif(ndiff)=i      
c               save symdif in (ntmpy,tmpy)
                ntmpy=ntmpy+1
		tmpy(ntmpy)=i
           endif
50    continue

c     ------------------------------------------------------------------
c     If there is no symmetric difference, path relinking is done.
c     ------------------------------------------------------------------
      if (ndiff.eq.0) then
	   return
      endif

c     ------------------------------------------------------------------
c     Evaluate exchanges in symdif and move according to best exchange.
c     ------------------------------------------------------------------
31    continue

60    if (ndiff .eq. 0) goto 70
c          print *,'PR: ndiff = ',ndiff

c          -------------------------------------------------------------
c          Find best exchange.
c          -------------------------------------------------------------
           bestx=-HUGE
	   do 80 i=1,ndiff
                node=symdif(i)
                if (x(node).eq.1) then
	            cost=sums(node)-sumsb(node)
		else
	            cost=sumsb(node)-sums(node)
		endif
	        if (cost .gt. bestx) then
		     bestx=cost
		     bestxi=i
		     bestxn=node
                endif
80         continue
c          -------------------------------------------------------------
c          Move using best exchange.
c          -------------------------------------------------------------
           objf=objf+bestx
           call mkmove(bestxn,n2e,ne,nS,nv,S,x,sums,sumsb,first,next,
     +                 edge,v,w)
c          print *,'PR after mkmove: nS: ',nS
c          print *,'PR after mkmove:  S: ',(S(i),i=1,nS)
c          print *,'PR after mkmove:  sums: ',(sums(i),i=1,nv)
c          print *,'PR after mkmove:  sumsb: ',(sumsb(i),i=1,nv)
c          call myflsh

c          -------------------------------------------------------------
c          Update best solution in PR.
c          -------------------------------------------------------------
           if (objf .gt. optz) then
		optz=objf
                flag=1
		call cpi4(nS,S,optS)
		noptS=nS
c               print *,'right after Update best sol..... optz = ',optz
c               call mkcost(nv,ne,x0,noptS,optS,vtx1,vtx2,w,optz)
           endif

c          -------------------------------------------------------------
c          Remove move from symmetric difference list.
c          -------------------------------------------------------------
	   do 90 i=bestxi,ndiff-1
	        symdif(i)=symdif(i+1)
90         continue
           ndiff=ndiff-1

	   goto 60
70    continue
c     ------------------------------------------------------------------
c     Recover symdif from tmpy and target in S from tmpx.
c     ------------------------------------------------------------------
      call cpi4(ntmpy,tmpy,symdif)
      ndiff=ntmpy
      call cpi4(ntmpx,tmpx,S)

c     print *,' ntmpx = ',ntmpx
c     call myflsh

      nS=ntmpx

      objf=objt
c      print *,' Before UPDELT noptS = ',noptS
c      call myflsh


c     ------------------------------------------------------------------
c     Update Elite set if necessary. 
c     ------------------------------------------------------------------
      if (flag.eq.1)
     +     call updelt(bestz,bS,bnS,faselt,felt,gitr,gitrb,indb,indw,
     +            mindif,nelt,
     +            nmelt,nmxelt,noptS,
     +            nv,nxtelt,objelt,optz,optS,seed0,seedb,xdiff,ydiff,
     +            velt,worstz,zimprv,elitex)

      if (redo.eq.1) then
           flag=0
	   redo=0
	   optzf=optz
       
c          -------------------------------------------------------------
c          S (target) is best solution in backward PR so far.
c          -------------------------------------------------------------
           optz=objf
c           call cpi4(nS,S,optS)
c           noptS=nS
           goto 31       
      endif
      objf=optz
      if (optz.lt.optzf) objf=optzf 

      return
      end
