      subroutine postpr(bestz,bnS,bS,edge,faselt,felt,
     +                  first,gitr,gitrb,indb,indw,mindif,
     +                  n2e,ne,nS,
     +                  nelt,next,
     +                  nmelt,nmxelt,nv,nxtelt,objelt,objf,S,
     +                  seed0,seedb,
     +                  sums,sumsb,symdif,tmpx,tmpy,
     +                  v,velt,w,
     +                  worstz,x,y,zimprv,first0,next0,v0,edge0,
     +                  optS,xdiff,ydiff,btime)
c     ------------------------------------------------------------------
c     postpr: Path relinking over all pairs of elite solutions.
c     ------------------------------------------------------------------
      implicit none
      integer HUGE
      parameter (HUGE=2147483647)
      integer i,ptr,ndiff,mindif,ne,n2e,nv,nmelt
      integer bestz,faselt,indb,indw,nS,nelt,nmxelt,objf,worstz,zimprv
      integer bnS,gitr,gitrb,seed0,seedb,node
      integer cost,bestx,bestxi,bestxn,elitex
      integer bS(nv),felt(nmxelt),nxtelt(nmelt),S(nv),velt(nmelt),
     +        objelt(nmxelt),x(nv),y(nv),sums(nv),sumsb(nv),
     +        xdiff(nv),ydiff(nv)
      integer first(nv),edge(n2e),next(n2e),v(n2e),w(ne),symdif(nv),
     +        tmpx(nv),tmpy(nv),first0(nv),next0(n2e),v0(n2e),
     +        edge0(n2e),optS(nv),noptS
      integer ssol,tsol,sumelt,optz
      real cput(2),btime,ttime,etime
c     ------------------------------------------------------------------
c     Double loop over all pairs of elite solutions (ssol,tsol)
c     ------------------------------------------------------------------
13    zimprv=0
      elitex=0
      do 11 ssol=1,nelt

      do 12 tsol=1,nelt
      if (tsol.eq.ssol) goto 12

      sumelt=0
      optz=-HUGE
      do 888 i=1,nelt
           sumelt=sumelt+objelt(i)
888   continue

      objf=objelt(ssol)

c     ------------------------------------------------------------------
c     Compute symmetric difference between S and target.
c     ------------------------------------------------------------------
      do 10 i=1,nv
           x(i)=0
           y(i)=0
10    continue
      nS=0
      ptr=felt(ssol)
301   if (ptr .eq. 0) goto 401
           x(velt(ptr))=1
	   nS=nS+1
	   S(nS)=velt(ptr)
           ptr=nxtelt(ptr)
	   goto 301
401   continue
      ptr=felt(tsol)
30    if (ptr .eq. 0) goto 40
           y(velt(ptr))=1
           ptr=nxtelt(ptr)
	   goto 30
40    continue

c     ------------------------------------------------------------------
c     Compute sums and sumsb
c     ------------------------------------------------------------------
      do 405 i=1,nv
           sums(i)=0
           sumsb(i)=0
	   ptr=first0(i)
406        if (ptr.eq.0) goto 404
                if (x(v0(ptr)).eq.1) then
		     sums(i)=sums(i)+w(edge0(ptr))
		else
		     sumsb(i)=sumsb(i)+w(edge0(ptr))
		endif
		ptr=next0(ptr)
		goto 406
404        continue
405   continue

c     ------------------------------------------------------------------
c     Compute symmetric difference between S and target elite solution.
c     ------------------------------------------------------------------
      ndiff=0
      do 50 i=1,nv
           if (x(i).ne.y(i)) then
	        ndiff=ndiff+1
		symdif(ndiff)=i
           endif
50    continue
c     ------------------------------------------------------------------
c     If there is no symmetric difference, path relinking is done.
c     ------------------------------------------------------------------
      if (ndiff.eq.0) goto 12

c     ------------------------------------------------------------------
c     Evaluate exchanges in symdif and move according to best exchange.
c     ------------------------------------------------------------------
60    if (ndiff .gt. 0) then

c          -------------------------------------------------------------
c          Find best exchange.
c          -------------------------------------------------------------
           bestx=-HUGE
	   do 80 i=1,ndiff
                node=symdif(i)
                if (x(node).eq.1) then
	            cost=sums(node)-sumsb(node)
		else
	            cost=sumsb(node)-sums(node)
		endif
	        if (cost .gt. bestx) then
		     bestx=cost
		     bestxi=i
		     bestxn=node
                endif
80         continue
c          -------------------------------------------------------------
c          Move using best exchange.
c          -------------------------------------------------------------
           objf=objf+bestx
           if (objf.gt.bestz) then
c               --------------------------------------------------------
c               Print new solution found.
c               --------------------------------------------------------
          	ttime=etime(cput)
                print *,' post pr:',
     +                  ' objf: ', objf,' time: ', cput(1)-btime
           endif
           call mkmove(bestxn,n2e,ne,nS,nv,S,x,sums,sumsb,first,next,
     +                 edge,v,w)

c	   -------------------------------------------------------------
c	   Update best solution in PR.
c	   -------------------------------------------------------------
           if (objf .gt. optz) then
                optz=objf
                call cpi4(nS,S,optS)
                noptS=nS
           endif

c          -------------------------------------------------------------
c          Remove move from symmetric difference list.
c          -------------------------------------------------------------
	   do 90 i=bestxi,ndiff
	        symdif(i)=symdif(i+1)
90         continue
           ndiff=ndiff-1

	   goto 60
      else
c          -------------------------------------------------------------
c          Update Elite set if necessary.
c          -------------------------------------------------------------
           if (tsol.ne.ssol) then 
                call updelt(bestz,bS,bnS,faselt,felt,gitr,gitrb,
     +                      indb,indw,mindif,nelt,
     +                      nmelt,nmxelt,noptS,
     +                      nv,nxtelt,objelt,optz,optS,seed0,seedb,
     +                      xdiff,ydiff,velt,worstz,zimprv,elitex)
           endif
      endif
12    continue
      if (elitex.eq.1) goto 13
11    continue
c     ------------------------------------------------------------------
      return
      end
