      subroutine prall(bestz,bnS,bS,edge,faselt,felt,
     +                  first,gitr,gitrb,indb,indw,mindif,
     +                  n2e,ne,nS,
     +                  nelt,next,
     +                  nmelt,nmxelt,nv,nxtelt,objelt,objf,S,seedp,
     +                  seed0,seedb,
     +                  sums,sumsb,symdif,tmpx,tmpy,
     +                  v,velt,w,
     +                  worstz,x,y,zimprv,optS,tmpS,xdiff,ydiff,
     +                  vtx1,vtx2)

c     ------------------------------------------------------------------
c     prall: Path relinking from current S to all targets in Elite set.
c     ------------------------------------------------------------------
      implicit none
      integer HUGE
      parameter (HUGE=2147483647)
      integer i,ptr,ndiff,mindif,ne,n2e,nv,nmelt,optz
      integer bestz,faselt,indb,indw,nS,nelt,nmxelt,objf,worstz,zimprv
      integer bnS,gitr,gitrb,seed0,seedb,seedp,target,bestx,node
      integer cost,bestxi,bestxn,elitex,noptS,objt
      integer bS(nv),felt(nmxelt),nxtelt(nmelt),S(nv),velt(nmelt),
     +        objelt(nmxelt),x(nv),y(nv),sums(nv),sumsb(nv),optS(nv),
     +        xdiff(nv),ydiff(nv)
      integer first(nv),edge(n2e),next(n2e),v(n2e),w(ne),symdif(nv),
     +        tmpx(nv),tmpy(nv),ntmpx,ntmpy,redo,tmpS(nv),ntmpS,tobjf
      real    xrand,randp
      integer  x0(nv)
      integer vtx1(ne),vtx2(ne)
c     ------------------------------------------------------------------
c     Save (nS,S) in (ntmpS,tmpS)
c     ------------------------------------------------------------------
     

      call cpi4(nS,S,tmpS)
      ntmpS=nS
      tobjf=objf

 
c     ------------------------------------------------------------------
c     Vary target from 1 to nelt (number of elite set solutions)
c     ------------------------------------------------------------------
      do 11 target=1,nelt
      redo=1
      
       call initpr (ne,n2e,nv,optz,objf,S,nS,
     +                    first,edge,next,sums,sumsb,v,w,target,
     +                    x,y,tmpx,ntmpx,tmpy,ntmpy, nmxelt,nmelt,
     +                    felt,velt,nxtelt,objelt,objt,tmpS,ntmpS,
     +                    tobjf,ndiff,symdif)

 
c     ------------------------------------------------------------------
c     If there is no symmetric difference, path relinking is done.
c     ------------------------------------------------------------------
      if (ndiff.eq.0) goto 11

c     ------------------------------------------------------------------
c     Evaluate exchanges in symdif and move according to best exchange.
c     ------------------------------------------------------------------
31    continue
60    if (ndiff .eq. 0) goto 70

            call updsol (ne,n2e,nv,optz,objf,S,nS,optS,noptS,
     +                   sums,sumsb,v,w,first,edge,next,x)

c          -------------------------------------------------------------
c          Find best exchange.
c          -------------------------------------------------------------
           bestx=-HUGE

c          call  mkcost(nv,ne,x0,nS,S,vtx1,vtx2,w,objf) 

	   do 80 i=1,ndiff
                node=symdif(i)
                if (x(node).eq.1) then
	            cost=sums(node)-sumsb(node)
		else
	            cost=sumsb(node)-sums(node)
		endif
	        if (cost .gt. bestx) then
		     bestx=cost
		     bestxi=i
		     bestxn=node
                endif
80         continue
c          -------------------------------------------------------------
c          Move using best exchange.
c          -------------------------------------------------------------
           

c          call  mkcost(nv,ne,x0,nS,S,vtx1,vtx2,w,objf) 

           objf=objf+bestx

           call mkmove(bestxn,n2e,ne,nS,nv,S,x,sums,sumsb,first,next,
     +                 edge,v,w)

c          call  mkcost(nv,ne,x0,nS,S,vtx1,vtx2,w,objf)  
         
c          -------------------------------------------------------------
c          Update best solution in PR.
c          -------------------------------------------------------------
           if (objf .gt. optz) then
		optz=objf
		call cpi4(nS,S,optS)
		noptS=nS
           endif

c          -------------------------------------------------------------
c          Remove move from symmetric difference list.
c          -------------------------------------------------------------
	   do 90 i=bestxi,ndiff-1
	        symdif(i)=symdif(i+1)
90         continue
           ndiff=ndiff-1

	   goto 60
70    continue


c     ------------------------------------------------------------------
c     Update Elite set if necessary.
c     ------------------------------------------------------------------

c     call  mkcost(nv,ne,x0,noptS,optS,vtx1,vtx2,w,optz) 
c     call  mkcost(nv,ne,x0,nS,S,vtx1,vtx2,w,objf)

      call updelt(bestz,bS,bnS,faselt,felt,gitr,gitrb,indb,indw,
     +            mindif,nelt,
     +            nmelt,nmxelt,noptS,
     +            nv,nxtelt,objelt,optz,optS,seed0,seedb,xdiff,ydiff,
     +            velt,worstz,zimprv,elitex)

       

      if (redo.eq.1) then

          
	   redo=0
c          ------------------------------------------------------------------
c           Recover symdif from tmpy and target in S from tmpx.
c          ------------------------------------------------------------------
           call cpi4(ntmpy,tmpy,symdif)
           ndiff=ntmpy
           call cpi4(ntmpx,tmpx,S)
           nS=ntmpx
           objf=objt

           do 95 i=1,nv
              x(i)=0
95         continue
  
            do 105 i=1,nS
              x(S(i))=1
105         continue
          
           goto 31       
      endif
11    continue

      


      return
      end



