      subroutine readp(errcnd,in,ne,nv,maxe,maxv,vtx1,vtx2,w)
c     ------------------------------------------------------------------

c     readp: inputs problem data

c     ------------------------------------------------------------------
c
c     Passed input parameters:
c
c          in     - input device number
c          maxe   - array dimension
c          maxv   - array dimension
c
c     ------------------------------------------------------------------
      implicit   none
      integer    in
      integer    maxe,maxv
c     ------------------------------------------------------------------
c
c     Passed input scalars:
c
c          nv     - number of nodes
c          ne     - number of arcs
c
c     ------------------------------------------------------------------
      integer    ne,nv
c     ------------------------------------------------------------------
c     
c     Passed output scalars:
c
c          errcnd - error condition
c
c     ------------------------------------------------------------------
      integer errcnd
c     ------------------------------------------------------------------
c
c     Passed output arrays:
c
c          vtx1   - node 1 of arc
c          vtx2   - node 2 of arc
c          w      - weight of arc (original)
c
c     ------------------------------------------------------------------
      integer    vtx1(maxe),vtx2(maxe),w(maxe)
c     ------------------------------------------------------------------
c
c     Local parameters:
c
c          i     - do loop parameter
c
c     ------------------------------------------------------------------
      integer    i
c     ------------------------------------------------------------------
      errcnd=0

c     ------------------------------------------------------------------
c     Read graph dimensions.
c     ------------------------------------------------------------------
      read (in,*) nv,ne

c     ------------------------------------------------------------------
c     Check if arrays have been dimensioned correctly.
c     ------------------------------------------------------------------
      if (nv .gt.maxv) then
           errcnd=1
           return
      endif

      if (ne .gt.maxe) then
           errcnd=2
           return
      endif

c     ------------------------------------------------------------------
c     Read arcs and their weights.
c     ------------------------------------------------------------------
      do 10 i=1,ne
c          -------------------------------------------------------------
c          Read directed edge = (v1,v2) and weight(v1,v2).
c          -------------------------------------------------------------
           read(in,*) vtx1(i),vtx2(i),w(i)

10    continue
c     ------------------------------------------------------------------
      return
c
c     ------------------------------------------------------------------
c     End of subroutine readp.
c     ------------------------------------------------------------------
      end
