      subroutine updelt(bestz,bS,bnS,faselt,felt,gitr,gitrb,indb,indw,
     +                  mindif,nelt,
     +                  nmelt,nmxelt,nS,
     +                  nv,nxtelt,objelt,objf,S,seed0,seedb,
     +                  xdiff,ydiff,
     +                  velt,worstz,zimprv,elitex)

c     ------------------------------------------------------------------
c     updelt: Updates elite set if necessary with new solution (nS,S).
c             Disallows inclusion of solutions with nS=0.
c     ------------------------------------------------------------------
      implicit none
      integer HUGE
      parameter (HUGE=2147483647)
      integer i,nd,ndiff,mindif,nv,nmelt,bnS,gitr,gitrb
      integer bestz,faselt,indb,indw,nS,nelt,nmxelt,objf,worstz,zimprv
      integer seed0,seedb,elitex
      integer bS(nv),felt(nmxelt),nxtelt(nmelt),S(nv),velt(nmelt),
     +        objelt(nmxelt),xdiff(nv),ydiff(nv)

c     print *,'UPDELT: nS = ',nS
c     call myflsh
      if (nS.eq.0 .or. nS.eq.nv) return
      if (nelt .lt. nmxelt) then
           if (nelt .eq. 0) then
c               --------------------------------------------------------
c               Elite set is empty.
c               --------------------------------------------------------
	   	nelt=1
		do 10 i=1,nS
                     velt(i)=S(i)
10              continue
	        felt(1)=1
		nxtelt(nS)=0
		faselt=nS+1
		worstz=objf
		objelt(1)=objf
		bestz=objf
		indb=1
		zimprv=1
		indw=1
                elitex=1
		call savsol(bS,bestz,bnS,gitr,gitrb,nS,nv,objf,S,
     +                           seed0,seedb,zimprv)
c     print *,' Number of elite solutions = ',nelt
c     print *,' elite = ',(velt(i),i=1,nS)
c     print *,' next  = ',(nxtelt(i),i=1,nS)
c     call myflsh





  		return
	   else
c               --------------------------------------------------------
c               Elite set is not empty or full.
c               --------------------------------------------------------
c               print *,'UPDELT: objf, bestz = ',objf,bestz
c               call myflsh
                if (objf .gt. bestz) then
		     call savsol(bS,bestz,bnS,gitr,gitrb,nS,nv,objf,S,
     +                           seed0,seedb,zimprv)

		     nelt=nelt+1
		     indb=nelt
		     objelt(indb)=objf
c                    ---------------------------------------------------
c                    Insert S into Elite set.
c                    ---------------------------------------------------
		     call inelt(nv,nmelt,nmxelt,nelt,faselt,nS,S,velt,
     +                          nxtelt,felt)
                     elitex=1
		     return
	        else
                     if (objf .lt. worstz) then
c                         ----------------------------------------------
c                         S is a new solution.  Insert it into Elite 
c                         if it different from the elite solutions.
c                         ----------------------------------------------
                          do 70 i=1,nelt
                               nd=ndiff(i,nS,nmelt,nmxelt,nv,S,
     +                                  velt,felt,nxtelt,xdiff,ydiff)
                               if (nd.lt.2) then
			            return
			       endif
70                        continue

		          worstz=objf
c                         ----------------------------------------------
c                         Insert S into Elite set.
c                         ----------------------------------------------
                          nelt=nelt+1
		          indw=nelt
			  objelt(nelt)=objf
		          call inelt(nv,nmelt,nmxelt,nelt,faselt,nS,S,
     +                               velt,nxtelt,felt)
                          elitex=1
		          return
		     else
c                         ----------------------------------------------
c                         Elite not full nor empty and objf is worse
c                         than best and better than worst: scan Elite
c                         to check if all Elite solutions are different
c                         from S.
c                         Note: hashing could be used here.
c                         ----------------------------------------------
                          do 20 i=1,nelt
			       nd=ndiff(i,nS,nmelt,nmxelt,nv,S,
     +                                  velt,felt,nxtelt,xdiff,ydiff)
                               if (nd.eq.0) then
				    return   
                               endif
20                        continue
                          nelt=nelt+1
			  objelt(nelt)=objf
                          call inelt(nv,nmelt,nmxelt,nelt,faselt,nS,S,
     +                               velt,nxtelt,felt)
                          elitex=1
		          return
		     endif
		endif
	   endif
      else
c          -------------------------------------------------------------
c          Elite is full and we must check if S should be put into
c          Elite set.
c          -------------------------------------------------------------
           if (objf .le. worstz) then
		return
	   endif
           if (objf .gt. bestz) then
		call savsol(bS,bestz,bnS,gitr,gitrb,nS,nv,objf,S,
     +                      seed0,seedb,zimprv)

c               --------------------------------------------------------
c               Remove indw solution from Elite set.
c               --------------------------------------------------------
		indb=indw
		call rmelt(indw,nmelt,nmxelt,faselt,nxtelt,
     +                     felt)
		objelt(indb)=objf
c               --------------------------------------------------------
c               Insert S into Elite set in position of old indw.
c               --------------------------------------------------------
		call inelt(nv,nmelt,nmxelt,indb,faselt,nS,S,velt,nxtelt,
     +                     felt)
                elitex=1
c               --------------------------------------------------------
c               Update worstz and indw in Elite set.
c               --------------------------------------------------------
                worstz=HUGE
		do 60 i=1,nelt
		     if (objelt(i).lt.worstz) then
                          worstz=objelt(i)
			  indw=i
                     endif
60              continue
		return
	    else
c               --------------------------------------------------------
c               S is better than worstz but is not better than 
c               bestz, so we need to check if it is sufficiently
c               distant from the Elite set solutions.  If it is,
c               we insert it into the place of the worst.
c               --------------------------------------------------------
                do 30 i=1,nelt
                     nd=ndiff(i,nS,nmelt,nmxelt,nv,S,velt,felt,
     +                        nxtelt,xdiff,ydiff)
                     if (nd.le.mindif) then
			  return   
                     endif
30              continue
		objelt(indw)=objf
		call rmelt(indw,nmelt,nmxelt,faselt,nxtelt,
     +                          felt)
                call inelt(nv,nmelt,nmxelt,indw,faselt,nS,S,velt,
     +                          nxtelt,felt)
                elitex=1
c               --------------------------------------------------------
c               Update worstz and indw in Elite set.
c               --------------------------------------------------------
                worstz=HUGE
		do 40 i=1,nelt
		     if (objelt(i).lt.worstz) then
                          worstz=objelt(i)
			  indw=i
                     endif
40              continue
		return
           endif
      endif
c     ------------------------------------------------------------------
c     End of updelt.
c     ------------------------------------------------------------------
      return
      end
