      subroutine warmup( seed )
c     ------------------------------------------------------------------
c
c     warmup: Warms up random number generator.
c
c     ------------------------------------------------------------------
c
c     Passed input/output scalars:
c
c          seed   - seed for pseudo random number generator
c
c     ------------------------------------------------------------------
      implicit   none
      integer    seed
c     ------------------------------------------------------------------
c
c     Local parameter:
c
c          wapitr - max number of warmup iterations
c
c     ------------------------------------------------------------------
      integer    wupitr
      parameter  (wupitr=100)

c     ------------------------------------------------------------------
c
c     Local scalars and functions:
c
c          i      - do loop index 
c          xrand  - random number
c          randp  - random number function
c
c     ------------------------------------------------------------------
      integer    i
      real       xrand,randp

c     ------------------------------------------------------------------
c     Call random number generator wupitr times to warm it up.
c     ------------------------------------------------------------------
      do 10 i=1,wupitr
           xrand=randp( seed )
10    continue

      return
c
c     ------------------------------------------------------------------
c     End of subroutine warmup.
c     ------------------------------------------------------------------
      end
